<template>
  <div class="routerWapper">
		<div>
      {{triggerType}} - {{labelId}}
      <a-row>
        <a-col :span='1' v-if="triggerType == 'create'">
          <a-button type='default' @click="backPage()">返回</a-button>
        </a-col>
        <a-col :span='1' v-else>
          <a-button type='default' @click="deleteLabel(labelId)">删除</a-button>
        </a-col>
        <!-- <a-col :span='1' :offset='1'>
          <a-button type='default'>编辑</a-button>
        </a-col> -->
        <a-col :span='1' :offset='1'>
          <a-button type='primary' @click="save()">保存</a-button>
        </a-col>
        <a-col :span='19'></a-col>
      </a-row>
    </div>
    <a-divider type='horizontal' />
    <a-form :form='labelForm'>
      <a-form-item label='标签名' :label-col="{span:2}" :wrapper-col="{span:14}">
        <a-input v-decorator="['labelName',{validateTrigger:'blur',rules: []}]"></a-input>
      </a-form-item>
      <a-form-item label='标签分组' :label-col="{span:2}" :wrapper-col="{span:14}">
        <a-select v-decorator="['parentLabel',{validateTrigger:'blur',rules: []}]"></a-select>
      </a-form-item>
      <a-form-item label='业务对象' :label-col="{span:2}" :wrapper-col="{span:14}">
        <a-select v-decorator="['businessObj',{validateTrigger:'blur',rules: []}]">
          <a-select-option value='xq'>小区</a-select-option>
          <a-select-option value='mpz'>门牌幢</a-select-option>
        </a-select>
      </a-form-item>
    </a-form>
    <a-row style="font-weight: bold">信息筛选配置</a-row>
    <a-form :form='infoSettingForm' layout='inline'>
      <div v-for="(item, index) in loopContent.data" :key='index'>
        <a-form-item v-if="!!item.relation">
          <a-select style="width: 120px" placeholder='请选择条件' v-decorator="['relation' + index,{initialValue: item.relation, validateTrigger:'blur',rules: []}]">
            <a-select-option value='and'>与</a-select-option>
            <a-select-option value='or'>或</a-select-option>
            <a-select-option value='ne'>非</a-select-option>
          </a-select>
        </a-form-item>

        <a-form-item v-else style="margin-left: 120px"></a-form-item>

        <a-form-item>
          <a-select style="width: 120px" placeholder='请选择业务属性' v-decorator="['key' + index,{initialValue: item.key, validateTrigger:'blur',rules: [{required: true, message: '请至少选择一项！'}]}]">
            <a-select-option value='sx1'>属性一</a-select-option>
            <a-select-option value='sx2'>属性二</a-select-option>
          </a-select>
        </a-form-item>

        <a-form-item>
          <a-select style="width: 120px" placeholder='区间' v-decorator="['codition' + index,{initialValue: item.codition, validateTrigger:'blur',rules: [{required: true, message: '请至少选择一项！'}]}]">
            <a-select-option value='equels'>等于</a-select-option>
            <a-select-option value='gt'>大于</a-select-option>
            <a-select-option value='gte'>大于等于</a-select-option>
            <a-select-option value='lt'>小于</a-select-option>
            <a-select-option value='lte'>小于等于</a-select-option>
            <a-select-option value='btw'>区间</a-select-option>
          </a-select>
        </a-form-item>

        <a-form-item>
          <a-input placeholder='请输入' v-decorator="['inputOne' + index,{initialValue: item.inputOne, validateTrigger:'blur',rules: [],}]"></a-input>
        </a-form-item>
        <a-form-item v-if="infoSettingForm.getFieldValue('codition'+index) == 'btw'">
          <a-input placeholder='请输入' v-decorator="['inputTwo' + index,{initialValue: item.inputTwo, validateTrigger:'blur',rules: []}]"></a-input>
        </a-form-item>

        <a-form-item>
          <a-select style="width: 120px" placeholder='查询方式' v-decorator="['selMet' + index,{initialValue: item.selMet, validateTrigger:'blur',rules: [{required: true, message: '请至少选择一项！'}]}]">
            <a-select-option value='equels'>精确</a-select-option>
            <a-select-option value='like'>模糊</a-select-option>
          </a-select>
        </a-form-item>
        {{loopContent.data.length}}
        {{index}}
        <a-form-item>
          <a-icon v-if="index+1 == loopContent.data.length" theme='filled' style="color:lightgreen;" type="plus-circle" @click="addRow()" />
          <a-icon v-if="index+1 == loopContent.data.length" theme='filled' style="color:red; margin-left: 5px" type="minus-circle" @click="deleteRow(index)" />
        </a-form-item>
      </div>
    </a-form>
    <a-modal :visible='deleteVisible' @ok='handleDeleteOk' @cancel='handleCancelOk'>
      确定删除该标签吗?
    </a-modal>
  </div>
</template>

<script>
export default {
  data() {
    return {
      labelForm: this.$form.createForm(this),
      infoSettingForm: this.$form.createForm(this),
      loopContent: {
        data: [{
          key: '',
          codition: 'equels',
          val: '',
          selMet: ''
        }]
      },
      jsonData: [],
      deleteVisible: false
    }
  },
  mounted() {
    console.log('得到的' + this.labelId)
    this.getLabelDetail()
  },
  props: [
    'triggerType',
    'labelId'
  ],
  watch: {
    triggerType: {
      handler: function(newV, oldV) {
        this.resetFormFields()
        this.getLabelDetail()
      },
      immediate: true
    },
    labelId: {
      handler: function(newV, oldV) {
        this.resetFormFields()
        this.getLabelDetail()
      },
      immediate: true
    }
  },
  methods: {
    getLabelDetail() {
      // console.log('得到的' + this.labelId)
      if(!!this.labelId && this.labelId !== 'undefined') {
        this.$ajax.get({
          url: this.$api.DELETE_SINGLE_LABEL.replace('{id}', this.labelId),
        }).then(res => {
          if (res.code == 200) {
            this.loopContent.data = res.data.content.selParams
            console.log(res.data.content.selParams)
          }
        })
      } else {
        this.resetFormFields()
      }
    },
    backPage(){ // 返回按钮
      this.$router.back()
    },
    addRow() {
      this.loopContent.data.push({
        key: '',
        codition: 'equels',
        val: '',
        relation: 'and',
        selMet: ''
      })
      console.log(this.loopContent)
    },
    deleteRow(index) {
      console.log(JSON.stringify(this.loopContent.data))
      console.log(index)
      this.loopContent.data.splice(index, 1)
      console.log(JSON.stringify(this.loopContent.data))
    },
    deleteLabel(id) {
      // 查询该标签是否是一级标签，是一级标签直接删除。
      this.deleteVisible = !this.deleteVisible
    },
    handleDeleteOk() {
      this.$message.success('标签【'+ this.labelId + '】已删除!')
      this.deleteVisible = !this.deleteVisible
    },
    handleCancelOk() {
      this.deleteVisible = !this.deleteVisible
    },
    resetFormFields() {
      this.loopContent.data = [{
        key: '',
        codition: 'equels',
        val: '',
        selMet: ''
      }]
    },
    save() {
      this.jsonData = []
      this.infoSettingForm.validateFields((err, values) => {
        if(!err) {
          let loopCounts = this.loopContent.data.length
          let formData = this.infoSettingForm.getFieldsValue()

          for(let i = 0; i < loopCounts; i++) {
            this.jsonData.push({
              key: formData['key'+i],
              val: !formData['inputTwo' + i] ? formData['inputOne' + i] : formData['inputOne' + i] + ',' + formData['inputTwo' + i],
              condition: formData['codition'+i],
              relation: formData['relation' + i],
              selMet: formData['selMet' + i]
            })
          }

          console.log(JSON.stringify(this.jsonData))
          this.$message.success('保存成功!')
        }
      })
      this.resetFormFields()
    },
  },
}
</script>